library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity bincnt is
	--Definition der Entity Ports
    Port (LED_n : out UNSIGNED (0 to 2);
           reset_n : in STD_LOGIC;
           clk : in STD_LOGIC);	  
end bincnt;

architecture verhalten of bincnt is
	-- Signale definieren
	signal CNT: UNSIGNED (19 downto 0) := (others => '0'); -- Counter/Timer
	signal LLL: UNSIGNED (0 to 2) := "000"; -- LED Zustandsvariable
	signal oldCNT: STD_LOGIC := '0'; -- Eine Variable um nderungen an CNT(19) zu berprfen
begin
	-- Ein simpler Zhler fr die Einschaltzeit einer LED
	COUNTER: process(clk)
	begin
		-- Bei ansteigender Flanke an clk
		if clk'event and clk = '1' then
			if reset_n = '0' then CNT <= (others => '0'); -- bei reset alles auf 0
			else CNT <= CNT + 1; -- zhlen
			end if;
		end if;
	end process;

	-- Zhler Prozess
	BINCNT: process(clk)
	begin
	   -- Bei ansteigender Flanke an clk
		if clk'event and clk = '1' then
			if reset_n = '0' then LLL <= "000"; -- bei reset alles auf 0
			-- nderung am MSB(CNT(19)) ? 
			elsif CNT(19) /= oldCNT then oldCNT <= CNT(19);
				-- Wenn MSB high, zhlen oder Neustart, wenn max. erreicht
				if CNT(19) = '1' then
					if LLL = "111" then LLL <= "000"; -- Neustart
					else LLL <= LLL + 1; -- addieren
					end if;
				end if;
			end if;
		end if;
	end process;
	-- Zuweisung der LLL Variable auf den LED Bus
	-- Invertierung da LED low aktiv
	LED_n <= NOT LLL;
end verhalten;

